package org.netkernel.xml.util;

import java.net.URI;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.w3c.dom.ls.LSInput;
import org.w3c.dom.ls.LSResourceResolver;

public class NKFLSResourceResolver implements LSResourceResolver
{
	INKFRequestContext mContext;
	
	public NKFLSResourceResolver(INKFRequestContext aContext)
	{	mContext=aContext;		
	}
	
	public LSInput resolveResource(
			String type,
			String namespaceURI,
			String publicId,
			String systemId,
			String baseURI
			)
	{	LSInput result=null;
		URI sys=URI.create(systemId);
		URI base=null;
		URI target=sys;
		if(!sys.isAbsolute())
		{	if(baseURI!=null)
			{	base=URI.create(baseURI);
			}
			else
			{	base=URI.create(mContext.getCWU());
			}
			target=base.resolve(sys);
		}
		try
		{	result=sourceTarget(target);
		}
		catch(Exception e)
		{	mContext.logRaw(mContext.LEVEL_WARNING, "Cannot Resolve "+systemId+" at "+target.toString() + " with base or CWU");
			if(namespaceURI!=null)
			{	base=URI.create(namespaceURI);
			}
			target=base.resolve(sys);
			try
			{	result=sourceTarget(target);				
			}
			catch(Exception e2)
			{	mContext.logRaw(mContext.LEVEL_WARNING, "Cannot Resolve "+systemId+" at "+ target.toString() + " with namespace URI");
			}
		}
		return result;
	}

	private LSInputImpl sourceTarget(URI target) throws Exception
	{	IReadableBinaryStreamRepresentation rbs=(IReadableBinaryStreamRepresentation)mContext.source(target.toString(), IReadableBinaryStreamRepresentation.class);
		return new LSInputImpl(rbs.getInputStream());
	}
	
}
